with Text_IO; use Text_IO;
with Ada.Strings.Unbounded;
with Lower_Layer_UDP;
with Datos_Bolsa;
with Handlers_Bolsa;
with Mensajes_Bolsa;
with Mensajes_Gong;
with Listas;
package body Control_Bolsa is

   package LLUDP renames Lower_Layer_UDP;
   package Datos renames Datos_Bolsa;
   package MEN renames Mensajes_Bolsa;
   package MENG renames Mensajes_Gong;

   -- package ASU renames Ada.Strings.Unbounded;



   Send_Stream: aliased Lower_Layer_UDP.Buffer_Type (1024);



   procedure pedir_Nombre (Nombre: out ASU.Unbounded_String) is

      Nom: String (1..80);
      Lon:   Natural;
   begin
      Put ("Nombre de Usuario: ");
      Get_Line (Nom, Lon);
      Nombre := ASU.To_Unbounded_String (Nom (Nom'First..Lon));
   end pedir_Nombre;

   procedure  Entrar is
      Mensaje: MENG.Inf_Nue_Usu;
      Expired: Boolean:=true;
      Mensaje2: MEN.Inf_Nue_Usu;
   begin

      -- Datos.Mi_Dir_Uni := Lower_Layer_Udp.Build;

      LLUDP.Bind_Any (Datos.Mi_Dir_Uni);
      --Datos.Gong_Address:= LLUDP.Build (Datos.Gong_IP, Datos.Gong_Port);

      while expired loop
         Pedir_Nombre (Mensaje.Nom_Usu);

         Datos_Bolsa.Nom_Usu:= Mensaje.nom_usu;

         Mensaje.Dir_Res := Datos.Mi_Dir_Uni;

         LLUDP.Reset (Send_Stream);

         MENG.Mens'Class'Output (Send_Stream'Access, MENG.Mens'Class(Mensaje));

         Put_Line ("Mando mensaje al gong");
         LLUDP.Send (Datos.Gong_Address, Send_Stream'access);

         Put_Line ("Despues de mandar el mensaje");
         -- Espero recibir el mensaje del gong
         LLUDP.Reset (Send_Stream);

         LLUDP.Receive (Datos.Mi_Dir_Uni, Send_Stream'access, Datos.Timeout, Expired);
         if not Expired then
            Put_Line ("Has entrado en la bolsa ...");
            Datos.dinero := Integer'Input (Send_Stream'Access);
            Datos.Acciones := Integer'Input (Send_Stream'Access);
            Put_Line ("Tienes " & Integer'Image(Datos.Dinero) &
                      " euros y " & Integer'Image(Datos.Acciones) &
                      " acciones ");
         end if;
      end loop;

      --Datos.Multi_Address := Lower_Layer_UDP.Build (
      --                                             Datos.Multi_IP,
      --                                             Datos.Multi_Port);

      -- Estaba handlers_bolsa.handl'access
      LLUDP.Bind (Datos.Multi_Address, Handlers_Bolsa.Handl'access);

      LLUDP.Reset (Send_Stream);
      Mensaje2.Nom_Usu:= Datos.Nom_Usu;
      Mensaje2.Dinero:= Datos.Dinero;
      Mensaje2.Acciones:= Datos.Acciones;
      MEN.Mens'Class'Output (Send_Stream'Access, MEN.Mens'Class(Mensaje2));
      LLUDP.Send (Datos.Multi_Address, Send_Stream'Access);

   end Entrar;

   procedure MandarOferta is
      Mensaje: MEN.Op_Oferta;
      Car: Character:=' ';
      Cad: String(1..80);
      Lon: Integer;
   begin
      Car:= ' ';
      Put_Line ("Antes del bucle");
      while (Car /='c' and Car/='v') loop
         Put_Line("Despues del bucle");
         Put ("Tipo de oferta(c/v): ");
         Get (Car);
         Skip_Line;
         --Put_Line("");
         if (Car='c' or Car='v') then
            Mensaje.Tip_Ofe:= Car;
            Put ("Cantidad: ");
            Get_Line (Cad, lon);
            --Put_Line ("leo la cantidad y voy a meterlo en el mensaje");
            Mensaje.Cantidad:= integer'Value(Cad(Cad'First..Lon));
            Put ("Precio: ");
            Get_Line (Cad, Lon);
            Mensaje.Precio := Integer'Value(Cad(Cad'First..Lon));
            Mensaje.Id_Ofertante:= Datos.Nom_Usu;

            -- El identificador de oferta es nombre de usuario seguido de un nmero que se va incrementando.
            Mensaje.Id_Oferta:= ASU.To_Unbounded_String
              (ASU.To_String(Datos.Nom_Usu)(1..ASU.To_String(Datos.Nom_Usu)'Length) & Integer'Image(Datos.Num_Oferta)(Integer'Image(Datos.Num_Oferta)'First+1..Integer'Image(Datos.Num_Oferta)'Last));
            Datos.Num_Oferta := Datos.Num_Oferta + 1;
         end if;


         LLUDP.Reset (Send_Stream);

         MEN.Mens'Class'Output (Send_Stream'Access, MEN.Mens'Class(Mensaje));

         LLUDP.Send (Datos.Multi_Address, Send_Stream'access);

         Put_Line ("He mandado una oferta ");

      end loop;

   end MandarOferta;

   procedure MandarAceptacion is

      Mensaje: MEN.Op_Acepta;
      Id_Of: String(1..80);
      Lon: Integer;
   begin

      Put ("Oferta que quieres aceptar?: ");
      Get_Line (Id_Of, lon);

      Mensaje.Id_Oferta := ASU.To_Unbounded_String (Id_Of(1..Lon));
      Mensaje.Id_Aceptador := Datos.Nom_Usu;

      LLUDP.Reset (Send_Stream);

      MEN.Mens'Class'Output (Send_Stream'Access, MEN.Mens'Class(Mensaje));

      LLUDP.Send (Datos.Multi_Address, Send_Stream'access);

      Put_Line ("He mandado una aceptacion ");


   end MandarAceptacion;


   procedure MostrarDatos is
   begin
      Put ("Nombre: " & ASU.To_String(Datos.Nom_Usu) & "  Dinero: " );
      Put_Line ( Integer'Image(Datos.Dinero) & "  Acciones: " & Integer'Image(Datos.Acciones) );
   end MostrarDatos;

   procedure Salir is
       Mensaje: MENG.Inf_Usu_Sal;
   begin
      Mensaje.Nom_Usu:= Datos.Nom_Usu;

      LLUDP.Reset (Send_Stream);

      MENG.Mens'Class'Output (Send_Stream'Access, MENG.Mens'Class(Mensaje));

      Put_Line ("Antes de mandar mensaje de despedida");
      LLUDP.Send (Datos.Multi_Address, Send_Stream'access);
      Put_Line ("Has salido de la bolsa");
      LLUDP.UnBind (Datos.Multi_Address);
   end Salir;

   procedure MostrarOfertas is
      Cont: Integer;
   begin
      for Cont in 1 .. Listas.T_Lista loop
         Put (ASU.To_String(Listas.LOferta(Cont).Id_Oferta) & ": " &  ASU.To_String(Listas.LOferta(Cont).Id_Ofertante) );
         if Listas.LOferta(Cont).Tip_Ofe='c' then
            Put (" compra ");
         else
            Put (" vende ");
         end if;
         Put_Line (Integer'Image(Listas.LOferta(Cont).Cantidad) & " acciones a " & Integer'Image(Listas.LOferta(Cont).Precio) & " euros");
      end loop;
   end MostrarOfertas;


end Control_Bolsa;








