with Ada.Strings.Unbounded;
with Lower_Layer_UDP;
with Lower_Layer_TCP;

package Datos_Bolsa is

   package LLUDP renames Lower_Layer_UDP;
   package ASU renames Ada.Strings.Unbounded;



   Multi_IP:   String := "224.8.7.6";
   Multi_Port: Integer := 9876;

   Multi_Address: Lower_Layer_UDP.End_Point_Type:= Lower_Layer_UDP.Build (Multi_IP, Multi_Port);

   Gong_IP: String := "127.0.0.1";
   Gong_Port: Integer:= 8362;

   Gong_Address: Lower_Layer_UDP.End_Point_Type:= Lower_Layer_UDP.Build (Gong_Ip, Gong_Port);


   Servidor_IP: ASU.Unbounded_String;
   Servidor_Port: Integer;

   Servidor_Address: Lower_Layer_TCP.End_Point;


   --  Has been received a Name_Exists message?
   --
   Nom_Existe: Boolean := False;

   -- The user name of this broker
   --
   Nom_Usu: ASU.Unbounded_String := ASU.To_Unbounded_String ("");

   NRonda: Integer:= 1;

   -- The  unicast address of this chat client.
   --
   Mi_Dir_Uni: Lower_Layer_UDP.End_Point_Type;

   Num_Oferta: Integer:=0;
   Dinero: Integer;
   Acciones: Integer;


   -- Tiempo que espera el broker para recibir confirmacion del nombre al entrar
   Timeout: Duration :=10.0;


end Datos_Bolsa;





