
with Mensajes_Bolsa;
with Lower_Layer_UDP;
with Ada.Characters.Handling;

package body Gong_HTTP is

   package MEN renames Mensajes_Bolsa;
   package LLUDP renames Lower_Layer_UDP;
   package ACH renames Ada.Characters.Handling;

   task body Servidor_HTTP is

      Peticion: ASU.Unbounded_String;
      -- Para separar la URL
      Tipopet, Inicio, Maquina, Puerto, Dirrel, Final: ASU.Unbounded_String;

      Pagina: ASU.Unbounded_String;

      TerminarTarea : Boolean:=False;

      Send_Stream: aliased Lower_Layer_UDP.Buffer_Type (1024);

      Serv_Conn: aliased LLTCP.Connection;
      Done: Boolean;

      A_Char: Character;
      --   A_String: String (1 .. 80);
      --   A_String_Filled: Integer;
      Almost_Done: Boolean := False;
      Dummy_Reply_Header: String :=
        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
        Ada.Characters.Latin_1.LF &
        "<HTML><HEAD>" &
        Ada.Characters.Latin_1.LF &
        "<TITLE>Example_HTTP_Assistant 0.0</TITLE>" &
        Ada.Characters.Latin_1.LF &
        "</HEAD><BODY>" &
        Ada.Characters.Latin_1.LF &
        "<H1>Example_HTTP_Assistant 0.0</H1>" &
        Ada.Characters.Latin_1.LF &
        "Your request was received and completely ignored!!!" &
        Ada.Characters.Latin_1.LF &
        "Cont value: ";

      Dummy_Reply_Footer: String :=
        Ada.Characters.Latin_1.LF &
        "</BODY></HTML>";

      -- ************************************************************************************************
      -- Parte de un Unbounded, que contiene una peticin de tipo put, o get, y lo separa en partes:    *
      -- El tipo de peticin, el nombre de mquina, el puerto, la direccin relativa y lo que va detrs *
      -- ************************************************************************************************
      procedure Separar_URL (Peticion: ASU.Unbounded_String) is
         PeticionS: String(1..500);
         Tamano: Integer;
         Num, Num2, Num3: Integer;
      begin
         TipoPet:= ASU.Null_Unbounded_String;
         Inicio:= ASU.Null_Unbounded_String;
         Maquina:= ASU.Null_Unbounded_String;
         Puerto:= ASU.Null_Unbounded_String;
         DirRel:= ASU.Null_Unbounded_String;
         Final:= ASU.Null_Unbounded_String;

         Tamano:= ASU.To_String(Peticion)'Length;
         PeticionS(1..Tamano):= ASU.To_String(Peticion);
         TIO.Put_Line ("La PETICIN A SEPARAR es: " & ASU.To_String(Peticion));

         -- Sacar el tipo de peticin, si es un GET o un PUT
         Num:= ASU.Index (Peticion, "GET");
         if Num>0 then
            Num2:= Num+4;
            TipoPet:= ASU.To_Unbounded_String (PeticionS(Num..Num+3));
         else
            Num:=ASU.Index (Peticion, "PUT");
            if Num>0 then
               Num2:=Num+4;
               TipoPet:= ASU.To_Unbounded_String (PeticionS(Num..Num+3));
            else
               TIO.Put_Line ("ERROR: No se ha encontrado ninguna peticin");
            end if;
         end if;

         -- Sacar lo que hay despus del GET o del PUT, pero antes del nombre de mquina, "siempre" http://
         Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)), "http://");
         Inicio:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num+5));
         Num2:=Num2+Num+6;

         -- Sacar el nombre de la mquina
         Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)), ":");
         if Num>0 then
            Maquina:=ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
            Num2:=Num2+Num;

            -- Saco el nmero de puerto
            Num:= ASU.Index (ASU.To_Unbounded_String(PeticionS(Num2..Tamano)),"/");
            if Num>0 then
               Puerto:=ASU.To_Unbounded_String(PeticionS(Num2..Num2+Num-2));
               Num2:=Num2+Num-1;
            else
               Num:= ASU.Index (ASU.To_Unbounded_String(PeticionS(Num2..Tamano))," ");
               Puerto:=ASU.To_Unbounded_String(PeticionS(Num2..Num2+Num-2));
               Num2:= Num2+Num;
            end if;
            if (PeticionS(Num2)='/') then
               Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
               DirRel:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
               Num2:=Num2+Num-1;
            else
               DirRel:= ASU.To_Unbounded_String("/");
            end if;
         else
            Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano)),"/");
            Num3:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-1))," ");
            if (Num>0 and Num3=0)then
               Maquina:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
               Num2:=Num2+Num-1;
               Puerto:= ASU.To_Unbounded_String ("80");
               if (PeticionS(Num2)='/') then
                  Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
                  DirRel:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
                  Num2:=Num2+Num-1;
               else
                  DirRel:= ASU.To_Unbounded_String("/");
               end if;
            else
               Num:= ASU.Index (ASU.To_Unbounded_String (PeticionS(Num2..Tamano))," ");
               Maquina:= ASU.To_Unbounded_String (PeticionS(Num2..Num2+Num-2));
               Puerto:= ASU.To_Unbounded_String ("80");
               DirRel:= ASU.To_Unbounded_String("/");
               Num2:=Num2+Num-1;
            end if;
         end if;

         Final:= ASU.To_Unbounded_String (PeticionS(Num2..Tamano-2));

         TIO.Put_Line ("TipoPet: " & ASU.To_String(Tipopet) & ASU.To_String(Tipopet));
         TIO.Put_Line ("Inicio:  " & ASU.To_String(Inicio) & ASU.To_String(Inicio));
         TIO.Put_Line ("Maquina: " & ASU.To_String(maquina) & ASU.To_String(Maquina));
         TIO.Put_Line ("Puerto:  " & ASU.To_String(puerto) & ASU.To_String(Puerto));
         TIO.Put_Line ("Dirrel:  " & ASU.To_String(dirrel) & ASU.To_String(Dirrel));
         TIO.Put_Line ("Final:   " & ASU.To_String(final) & ASU.To_String(Final));
      end Separar_URL;


      -- ***************************************************************************************
      -- *        Esta funcin lee de Serv_Conn, una peticin hasta que le llegan dos LF       *
      -- ***************************************************************************************
      function Extraer_Peticion return ASU.Unbounded_String is
         Done, Almost_Done, Comando_Leido: Boolean := False;
         Peticion: ASU.Unbounded_String:= ASU.Null_Unbounded_String;
         A_Char: Character;
      begin
         Done := False;
         while not Done loop
            Character'Read (Serv_Conn'Access, A_Char);
            Peticion:= ASU.To_Unbounded_String (ASU.To_String(Peticion) & A_Char);
            case A_Char is
               when Ada.Characters.Latin_1.LF =>
                  if (not Comando_Leido) then
                     Comando_Leido:=True;
                     Separar_URL (Peticion);
                  end if;

                  if Almost_Done then
                     Done := True;
                  else
                     Almost_Done := True;
                  end if;
               when Ada.Characters.Latin_1.CR =>
                  Almost_Done:= Almost_Done;
               when others =>
                  Almost_Done := False;
            end case;
         end loop;
         return (Peticion);
      end Extraer_Peticion;

      function PagError return ASU.Unbounded_String is
         Pag: ASU.Unbounded_String;
      begin
         Pag:= ASU.To_Unbounded_String (
                                        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
                                        Ada.Characters.Latin_1.LF &
                                        "<HTML><HEAD>" &
                                        Ada.Characters.Latin_1.LF &
                                        "<TITLE>Pgina no existe</TITLE>" &
                                        Ada.Characters.Latin_1.LF &
                                        "</HEAD><BODY>" &
                                        Ada.Characters.Latin_1.LF &
                                        "<center><H1>No existe la pgina</H1></center>" &
                                        Ada.Characters.Latin_1.LF &
                                        "</BODY></HTML>" &
                                        Ada.Characters.Latin_1.LF
                                       );
         return Pag;

      end PagError;


      function PagCuentas return ASU.Unbounded_String is

         Pag: ASU.Unbounded_String;
      begin
         Pag:= ASU.To_Unbounded_String (
                                        "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML 2.0//EN"">" &
                                        Ada.Characters.Latin_1.LF &
                                        "<HTML><HEAD>" &
                                        Ada.Characters.Latin_1.LF &
                                        "<TITLE>Cuentas de los brokers</TITLE>" &
                                        Ada.Characters.Latin_1.LF &
                                        "</HEAD><BODY>" &
                                        Ada.Characters.Latin_1.LF &
                                        "<center><H1>Cuentas</H1>" &
                                        Ada.Characters.Latin_1.LF);
         for Bucle in 1 .. Listas.T_Lista loop
            Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & ASU.To_String(Listas.LCuentas(Bucle).Nom_Usu) & " : ");
            Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & Integer'Image(Listas.LCuentas(Bucle).acciones) & " acciones y " & Integer'Image(Listas.LCuentas(Bucle).dinero) & " euros <BR>");
            Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & ACL.LF);
         end loop;


         Pag:= ASU.To_Unbounded_String (ASU.To_String(Pag) & "</center>" &
                                        Ada.Characters.Latin_1.LF &
                                        "</BODY></HTML>" &
                                        Ada.Characters.Latin_1.LF
                                       );
         return Pag;

      end PagCuentas;


      procedure MandarPagina (Pagina: ASU.Unbounded_String) is

      begin
         String'Write (Serv_Conn'Access, ASU.To_String(Pagina));

      end MandarPagina;



   begin

      while (not TerminarTarea) loop
         select
            -- COMIENZA LA TAREA
            accept Start do

               TIO.Put_Line (" Me pongo a escuchar ");

            end Start;

            DGON.SerGong_Address := LLTCP.Build (ASU.To_String(DGON.SerGong_IP), DGON.SerGong_Port);
            TIO.Put_Line (" Me pongo a escuchar ");
            LLTCP.Listen_Connection (DGON.SerGong_Address);
            TIO.Put_Line ("Despus del listen");
            loop
               LLTCP.Wait_Connection (DGON.SerGong_Address, Serv_Conn);
               TIO.Put_Line ("Connection accepted");

               Peticion := Extraer_Peticion;

               TIO.Put_Line (ASU.To_String(Peticion));

               TIO.Put_Line ("Inicio= " & ASU.To_String(Inicio));

               Pagina := ASU.To_Unbounded_String ("");

               if (ASU.To_String(Inicio) = "/ HTTP") then
                  Pagina:= PagCuentas;
               else
                  Pagina := PagError;
               end if;

               MandarPagina (Pagina);


               LLTCP.Dispose (Serv_Conn);
               TIO.Put_Line ("Connection closed by server");

            end loop;

         or
            accept Stop do
               TerminarTarea:= True;
            end Stop;
         end select;
      end loop;
   end Servidor_HTTP;
end Gong_HTTP;
