with Text_IO;
with Datos_Bolsa;
with Listas;

package body mensajes_bolsa is

   package Datos renames Datos_Bolsa;
   package TIO renames Text_IO;


   -- Stream for sending data.
   --
   Send_Stream: aliased Lower_Layer_UDP.Buffer_Type (1024);

   -------------------------------------------------------------------
   -- Procesar  (Pet_Usu_Nue)
   -------------------------------------------------------------------

   --procedure Procesar (Mensaje: in Pet_Usu_Nue) is

   --   use type ASU.Unbounded_String;
   --   use type Lower_Layer_UDP.End_Point_Type;

   --   Resp: Res_Nom_Usu_Usado;

   --begin
   --   if (Mensaje.Nom_Usu = Datos.Nom_Usu) then
   --      (Mensaje.Dir_Res /= Datos.My_Uni_Address) then
   --      Resp.Nom_Usu := Datos.Nom_Usu;
   --      Lower_Layer_UDP.Reset (Send_Stream);
   --      Mens'Class'Output (Send_Stream'Access,
   --                            Mens'Class (Resp));
   --      Lower_Layer_UDP.Send (Mensaje.Dir_Res,
   --                        Send_Stream'Access);
   --   end if;
   --end Procesar;

   -------------------------------------------------------------------
   -- Procesar (Res_Nom_Usu_Usado)
   -------------------------------------------------------------------

   --procedure Procesar (Mensaje: in Res_Nom_Usu_Usado) is

   --   use type ASU.Unbounded_String;

   --begin
   --   TIO.Put_Line ("Nombre ya existe: " &
   --                     ASU.To_String (Mensaje.Nom_Usu));
   --   if Mensaje.Nom_Usu = Datos.Nom_Usu then
   --      -- *************** CAMBIAR *********************************
   --      Datos.Name_Exists_Received := True;
   --   end if;
   --end Procesar;

   -------------------------------------------------------------------
   -- Process (Inf_Nue_Usu)
   -------------------------------------------------------------------

   procedure Procesar (Mensaje: in Inf_Nue_Usu) is

   begin
      if ( ASU."/="(Mensaje.Nom_Usu, Datos.Nom_Usu)) then
         TIO.Put_Line ("");
         TIO.Put_Line ("Nuevo broker: " &
                       ASU.To_String (Mensaje.Nom_Usu) & ": " &
                       Integer'Image (Mensaje.Dinero) & " euros y " &
                       Integer'Image (Mensaje.Acciones) & " acciones");
      end if;
   end Procesar;

   -------------------------------------------------------------------
   -- Process (Inf_Usu_Sal)
   -------------------------------------------------------------------

   procedure Procesar (Mensaje: in Inf_Usu_Sal) is

   begin
      if (ASU."/="(mensaje.Nom_Usu, Datos.Nom_Usu)) then
         TIO.Put_Line ("");
         TIO.Put_Line ("Este ha dejao la bolsa: " &
                           ASU.To_String (Mensaje.Nom_Usu));
      end if;
   end Procesar;

   -------------------------------------------------------------------
   -- Process (Operacion(compra/venta))
   -------------------------------------------------------------------

   procedure Procesar (Mensaje: in Op_Oferta) is

      use type ASU.Unbounded_String;
   begin
      -- Guardo los datos en la lista
      Listas.LOferta(Listas.Ind_Oferta).Tip_Ofe := Mensaje.Tip_Ofe;
      Listas.LOferta(Listas.Ind_Oferta).Cantidad := Mensaje.Cantidad;
      Listas.LOferta(Listas.Ind_Oferta).Precio := Mensaje.Precio;
      Listas.LOferta(Listas.Ind_Oferta).Id_Oferta := Mensaje.Id_Oferta;
      Listas.LOferta(Listas.Ind_Oferta).Id_Ofertante := Mensaje.Id_Ofertante;
      if (Listas.Ind_Oferta<Listas.T_Lista) then
         Listas.Ind_Oferta:= Listas.Ind_Oferta + 1;
      else
         Listas.Ind_Oferta:= 1;
      end if;


      if Mensaje.Id_Ofertante /= Datos.Nom_Usu then


         -- Muestro un mensaje en pantalla
         TIO.Put_Line ("");
         TIO.Put (ASU.To_String (Mensaje.Id_Oferta) & ": ");
         TIO.Put (ASU.To_String (Mensaje.Id_Ofertante) & ": ");
         if (Mensaje.Tip_Ofe='c') then
            TIO.Put (" compra ");
         else
            TIO.Put (" vende ");
         end if;
         TIO.Put_Line (Integer'Image(Mensaje.Cantidad) & " acciones a " &
                  Integer'Image(Mensaje.Precio));
      end if;
   end Procesar;

   ------------------------------------------------------------------
   -- Procesar (Aceptacion)
   ------------------------------------------------------------------

   procedure Procesar (Mensaje: in Op_Acepta) is
      Ind: Integer;

      Send_Stream: aliased Lower_Layer_UDP.Buffer_Type (1024);
      Mensaje2: Compro;
   begin

      if (ASU.To_String(Mensaje.Id_Aceptador) /= ASU.To_String(Datos.Nom_Usu)) then
         TIO.Put_Line ("");
         TIO.Put_Line (ASU.To_String (Mensaje.Id_Aceptador) & " acepta " &
                       " la operacion " & ASU.To_String (Mensaje.Id_Oferta));

         if (ASU.To_String(Datos.Nom_Usu) = ASU.To_String(Mensaje.Id_Oferta)(1..ASU.To_String(Datos.Nom_Usu)'Length)) and (""/=ASU.To_String(Datos.Nom_Usu)) Then
            Ind := Listas.NumOferta (Mensaje.Id_Oferta);
            --TIO.Put_Line (" Indice en la lista " & Integer'Image (Ind));
            if not Listas.LOferta(Ind).Comprometida then
               TIO.Put_Line ("Mando compromiso");

               LLUDP.Reset (Send_Stream);

               Listas.LOferta(Ind).Comprometida := True;
               Mensaje2.Id_Oferta:= Mensaje.Id_Oferta;
               Mensaje2.Id_Aceptador := Mensaje.Id_Aceptador;
               Mens'Class'Output (Send_Stream'Access, Mens'Class(Mensaje2));

               LLUDP.Send (Datos.Multi_Address, Send_Stream'access);

               if (Listas.LOferta(Ind).Tip_Ofe = 'c') then
                  Datos.Acciones := Datos.Acciones + Listas.LOferta(Ind).Cantidad;
                  Datos.Dinero := Datos.Dinero - (Listas.LOferta(Ind).Cantidad * Listas.LOferta(Ind).Precio);
               else
                  Datos.Acciones := Datos.Acciones - Listas.LOferta(Ind).Cantidad;
                  Datos.Dinero := Datos.Dinero + (Listas.LOferta(Ind).Cantidad * Listas.LOferta(Ind).Precio);
               end if;

            end if;
         end if;
      end if;
      TIO.Put_Line ("Salgo de procesar aceptacin");

   end Procesar;

   -----------------------------------------------------------------
   -- Procesar (Gong)
   -----------------------------------------------------------------

   procedure Procesar (Mensaje: in Inf_Gong) is
      Valor: Integer;
      Bucle: Integer;
   begin
      Valor := 1;
      TIO.Put_Line ("N Ronda: " & Integer'Image(Mensaje.N_Ronda));

      for Bucle in 1 .. Listas.T_Lista loop
         Listas.LCuentas(Bucle).Dinero := Listas.LCuentas(Bucle).Dinero + (Listas.LCuentas(Bucle).Acciones * Valor);
      end loop;

      Datos.Nronda := Mensaje.N_Ronda;
      Datos.Dinero := Datos.Dinero + (Datos.Acciones * Valor);
   end Procesar;

   -----------------------------------------------------------------
   -- Procesar (Compromiso)
   -----------------------------------------------------------------

   procedure Procesar (Mensaje: in Compro) is
      Ind: Integer;
      Ind2, Ind3: Integer;

   begin


      TIO.Put_Line ("Entro en procesar compromiso");
      if (ASU.To_String(Datos.Nom_Usu) = ASU.To_String(Mensaje.Id_Aceptador)) then
         TIO.Put_Line ("Me han comprometido la aceptacin");

         --------- HACER CUENTAS ................
         Ind := Listas.NumOferta (Mensaje.Id_Oferta);
         if (Listas.LOferta(Ind).Tip_Ofe = 'c') then
               Datos.Acciones := Datos.Acciones - Listas.LOferta(Ind).Cantidad;
               Datos.Dinero := Datos.Dinero + (Listas.LOferta(Ind).Cantidad * Listas.LOferta(Ind).Precio);
            else
               Datos.Acciones := Datos.Acciones + Listas.LOferta(Ind).Cantidad;
               Datos.Dinero := Datos.Dinero - (Listas.LOferta(Ind).Cantidad * Listas.LOferta(Ind).Precio);
            end if;
      end if;

      if (ASU.To_String(Datos.Nom_Usu) = "") then
         TIO.Put_LIne ("Soy gong y hago cuentas");

         Ind:= Listas.NumOferta (Mensaje.Id_Oferta);

         Ind2:= Listas.NumUsu (Listas.LOferta(Ind).Id_Ofertante);

         Ind3:= Listas.NumUsu (Mensaje.Id_Aceptador);

         if Listas.LOferta(Ind).Tip_Ofe = 'c' then
            Listas.LCuentas(Ind2).Dinero := Listas.LCuentas(Ind2).Dinero - (Listas.LOferta(Ind).cantidad * Listas.LOferta(Ind).precio);
            Listas.Lcuentas(Ind2).Acciones := Listas.LCuentas(Ind2).Acciones + Listas.LOferta(Ind).Cantidad;
            Listas.LCuentas(Ind3).Dinero := Listas.LCuentas(Ind3).Dinero + (Listas.LOferta(Ind).cantidad * Listas.LOferta(Ind).precio);
            Listas.Lcuentas(Ind3).Acciones := Listas.LCuentas(Ind3).Acciones - Listas.LOferta(Ind).Cantidad;
         else
            Listas.LCuentas(Ind2).Dinero := Listas.LCuentas(Ind2).Dinero + (Listas.LOferta(Ind).cantidad * Listas.LOferta(Ind).precio);
            Listas.Lcuentas(Ind2).Acciones := Listas.LCuentas(Ind2).Acciones - Listas.LOferta(Ind).Cantidad;
            Listas.LCuentas(Ind3).Dinero := Listas.LCuentas(Ind3).Dinero - (Listas.LOferta(Ind).cantidad * Listas.LOferta(Ind).precio);
            Listas.Lcuentas(Ind3).Acciones := Listas.LCuentas(Ind3).Acciones + Listas.LOferta(Ind).Cantidad;
         end if;
      end if;
   end Procesar;

end Mensajes_Bolsa;










